;WriteStr v1.10

	include	"tios.h"
	include	"mac2.h"
	include	"exec.inc"

	xdef		_ti92plus				;on for 92p
	;xdef		_ti89					;on for 89
	xdef		_nostub

;_begin:				;Not really needed
;	bra		_main		;Only needed for some programs to recognize
;	cnop		0,4		; it as a valid ASM program (doors,(plus)shell)
;	dc.b		"68kP"
;	dc.w		0
;	dc.w		_comment-_begin
;	dc.w		_main-_begin
;	dc.w		0,3,0,0,0,0,0,0,0,0,0,0

_main:
	movem.l	d3-d7/a2-a6,-(a7)
					;Store address of Jump Table for later use
	move.l	JUMP_TABLE,a2
					;Load address of last bit of last parameter
	move.l	top_estack(a2),a4
	move.l	(a4),a4
						;Tests parameters, then store them
	bsr		expr			;X
	move.l	d1,d4
	cmp.w 	#239,d4				;on for 92p
	;cmp.w 	#159,d4				;on for 89
	bgt		er5
	bsr		expr			;Y
	move.l	d1,d5
	cmp.w 	#102,d5				;on for 92p
	;cmp.w 	#76,d5				;on for 89
	bgt		er5
	bsr		expr			;Color
	move.l	d1,d6
	cmp.w		#4,d6
	bgt		er5
	bsr		expr			;Font
	move.l	d1,d7
	cmp.w		#2,d7
	bgt		er5
str:						;Test string
	cmp.b		#$E5,(a4)
	beq		er4
	cmp.b		#$2D,(a4)
	bne		er3
	move.b	-(a4),d0
againstr:
	tst.b		-(a4)
	beq		okstr
	bra		againstr
okstr:
	move.b	-(a4),d0
	cmp.b		#$E5,d0
	bne		er1
	lea		2(a4),a3
						;move below toolbar
	add.b 	#$12,d5				;on for 92p
	;add.b 	#$10,d5				;on for 89
						;transfer graph screen to LCD MEM
	Exec		cmd_dispg
						;displays the string
	SetFont	d7
	WriteStrA 	d4,d5,d6,a3
						;transfer LCD MEM to graph screen
	HDeref	#$0010				;on for 92p
	;HDeref	#$0012				;on for 89
	add.l		#4,a0
	lea.l 	LCD_MEM+$21C,a1			;on for 92p
	;lea.l 	LCD_MEM+$1e0,a1			;on for 89
	move.l	#102,d1				;on for 92p
	;move.l	#76,d1				;on for 89
lcd2gr2:
	move.l	#29,d0				;on for 92p
	;move.l	#19,d0				;on for 89
lcd2gr:
	move.b	(a1)+,(a0)+
	dbra		d0,lcd2gr
	;lea		$A(a1),a1				;on for 89
	dbra		d1,lcd2gr2
	bra		exit
						;setup error message
er1:	move.w	#940,-(a7)		;too many args
	bra		error
er2:	move.w	#210,-(a7)		;data type
	bra		error
er3:	move.w	#130,-(a7)		;must be string
	bra		error
er4:	move.w	#930,-(a7)		;too few args
	bra		error
er5:	move.w	#260,-(a7)		;domain


error:					;Usage and Error message
	Exec		ERD_dialog
	lea		2(a7),a7
	pea		_comment(pc)	;Put usage in Status Bar
	Exec		ST_helpMsg
	lea		4(a7),a7
;	lea		ret_val(pc),a3	;Return a value
;	move.l	top_estack(a2),a0
;	move.l 	a3,$12(a0)

exit:
	SetFont	#1
	movem.l	(a7)+,d3-d7/a2-a6
	rts
;-----------------------------------------sub routines
expr:						;Test expression
	clr.l		d1
	cmp.b		#$E5,(a4)
	beq		not_enough
	cmp.b		#$1F,(a4)
	bne		not_good_var
	move.b	-(a4),d0
	tst.b		d0
	beq		zeroF
	cmp.b		#1,d0
	bne		not_good_domain
	move.b	-(a4),d1
zeroF:
	move.b	-(a4),d0
	rts

not_enough:
	lea		4(a7),a7
	bra		er4
	
not_good_var:
	lea		4(a7),a7
	bra		er2

not_good_domain:
	lea		4(a7),a7
	bra		er5

;-----------------------------------------------------
;nothin	dc.b	0
_comment	dc.b	"WriteStr(X,Y,COL,FONT,STR)",0
;ret_val	dc.b	$2D
;-----------------------------------------------------
	end